﻿using C1.WPF.FlexGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ComboBoxValueUpdate
{
    /// <summary>
    /// Interaction logic for ProductWindow.xaml
    /// </summary>
    public partial class ProductWindow : Window
    {
        private string _windowType = null;
        private C1FlexGrid _grid;
        public ProductWindow()
        {
            InitializeComponent();
        }

        public ProductWindow(string windowType, C1FlexGrid c1FlexGrid)
        {
            InitializeComponent();
            _windowType = windowType;
            _grid = c1FlexGrid;
            lineCmbBox.ItemsSource = Product.GetLines();
            colorCmbBox.ItemsSource = Product.GetColors();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            if (_windowType == "Add")
            {
                this.Title = "Add Product";
                submitBtn.Content = "Add";
                submitBtn.Click += AddBtn_Click;
            }
            else
            {
                this.Title = "Edit Product";
                submitBtn.Content = "Edit";
                submitBtn.Click += EditBtn_Click;
                if (_grid.SelectedIndex >= 0 && _grid.SelectedIndex < (_grid.ItemsSource as ObservableCollection<Product>).Count)
                {
                    var productData = _grid.SelectedItem as Product;
                    nameTxtBox.Text = productData.Name;
                    if(productData.ProductColor != null)
                        colorCmbBox.SelectedItem = Product.GetColors()[Array.IndexOf(Product.GetColors(), productData.ProductColor)];
                    if (productData.Line != null)
                        lineCmbBox.SelectedItem = Product.GetLines()[Array.IndexOf(Product.GetLines(), productData.Line)];
                }
            }
        }

        private void AddBtn_Click(object sender, RoutedEventArgs e)
        {
            var data = _grid.ItemsSource as ObservableCollection<Product>;
            data.Add(new Product()
            {
                ProductColor = colorCmbBox.SelectedItem as string,
                Line = lineCmbBox.SelectedItem as string,
                Name = nameTxtBox.Text
            });
            this.Close();
        }

        private void EditBtn_Click(object sender, RoutedEventArgs e)
        {
            if (_grid.SelectedIndex >= 0 && _grid.SelectedIndex < (_grid.ItemsSource as ObservableCollection<Product>).Count)
            {
                var data = _grid.SelectedItem as Product;
                data.ProductColor = colorCmbBox.SelectedItem as string;
                data.Line = lineCmbBox.SelectedItem as string;
                data.Name = nameTxtBox.Text;
            }
            this.Close();
        }
    }
}
